#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    mpz_init_set_ui(mzVal1,0);
    mpz_init(mzVal2);
    mpz_init(mzResult);

    mpz_set_ui(mzVal2,0);
    mpz_set_ui(mzResult,0);
    bVal1=false;
    bVal2=false;
    ulN=0;

    iBase=10;
    ulLen=1024;
    ui->pBA->setEnabled(false);
    ui->pBB->setEnabled(false);
    ui->pBC->setEnabled(false);
    ui->pBD->setEnabled(false);
    ui->pBE->setEnabled(false);
    ui->pBF->setEnabled(false);
    ui->rbDec->setChecked(true);
    ui->rbInt->setChecked(true);
    ui->rbFloat->setEnabled(false);

    this->setWindowFlags(Qt::Window | Qt::WindowSystemMenuHint);

}

void MainWindow::Calc(QString strOper)
{
    char *cBuf=new char[ulLen];

    if (ui->le->text().trimmed()!="")
    {
        bClear=true;
        if (bVal1==false)
        {
            mpz_set_str(mzVal1,ui->le->text().trimmed().toAscii(),iBase);
            strCurrentEvent=strOper;
            bVal1=true;
            return;
        }
        if ((bVal1==true)&&(bVal2==false))
        {
            mpz_set_str(mzVal2,ui->le->text().trimmed().toAscii(),iBase);
            if (strCurrentEvent==strOper)
            {
                if (strOper=="and")
                {
                    mpz_and(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="or")
                {
                    mpz_ior(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="xor")
                {
                    mpz_xor(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="lcm")
                {
                    mpz_lcm(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="gcd")
                {
                    mpz_gcd(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="mod")
                {
                    mpz_mod(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="/")
                {
                    mpz_cdiv_q(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="*")
                {
                    mpz_mul(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="-")
                {
                    mpz_sub(mzResult,mzVal1,mzVal2);
                }
                if (strOper=="+")
                {
                    mpz_add(mzResult,mzVal1,mzVal2);
                }
            }
            strCurrentEvent=strOper;
            mpz_set(mzVal1,mzResult);

            mpz_set_ui(mzVal2,0);
            //gmp_sprintf(cBuf,"%Zd",mzResult);
            mpz_get_str(cBuf,iBase,mzResult);
            ui->le->setText(QString(cBuf));
        }
    }
    else
    {
        return;
    }

    delete cBuf;
}

void MainWindow::keyPressEvent(QKeyEvent * event)
{
    switch(event->key())
    {
        case 48:
            on_pB0_clicked();
            break;
        case 49:
            on_pB1_clicked();
            break;
        case 50:
            on_pB2_clicked();
            break;
        case 51:
            on_pB3_clicked();
            break;
        case 52:
            on_pB4_clicked();
            break;
        case 53:
            on_pB5_clicked();
            break;
        case 54:
            on_pB6_clicked();
            break;
        case 55:
            on_pB7_clicked();
            break;
        case 56:
            on_pB8_clicked();
            break;
        case 57:
            on_pB9_clicked();
            break;
        case 65:
            on_pBA_clicked();
            break;
        case 66:
            on_pBB_clicked();
            break;
        case 67:
            on_pBC_clicked();
            break;
        case 68:
            on_pBD_clicked();
            break;
        case 69:
            on_pBE_clicked();
            break;
        case 70:
            on_pBF_clicked();
            break;

        case 43:
            on_pbPlus_clicked();
            break;
        case 42:
            on_pbMul_clicked();
            break;
        case 45:
            on_pbMinus_clicked();
            break;
        case 47:
            on_pbDiv_clicked();
            break;
        case Qt::Key_Escape:
            on_pbC_clicked();
            break;
        case Qt::Key_Backspace:
            on_pbBack_clicked();
            break;
        case Qt::Key_Enter:
            on_pbEq_clicked();
            break;
        case Qt::Key_Return:
            on_pbEq_clicked();
            break;
        default:
            qDebug()<<event->key();
            QWidget::keyPressEvent(event);
    }
    return;
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pB1_clicked()
{
    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("1");
    }
    else
    {
        ui->le->setText(ui->le->text()+"1");
    }
}

void MainWindow::on_pB2_clicked()
{
    if (iBase*iBase<9) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("2");
    }
    else
    {
        ui->le->setText(ui->le->text()+"2");
    }
}

void MainWindow::on_pB3_clicked()
{
    if (iBase*iBase<16) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("3");
    }
    else
    {
        ui->le->setText(ui->le->text()+"3");
    }
}

void MainWindow::on_pB4_clicked()
{
    if (iBase*iBase<25) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("4");
    }
    else
    {
        ui->le->setText(ui->le->text()+"4");
    }
}
void MainWindow::on_pB5_clicked()
{
    if (iBase*iBase<36) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("5");
    }
    else
    {
        ui->le->setText(ui->le->text()+"5");
    }
}

void MainWindow::on_pB6_clicked()
{
    if (iBase*iBase<49) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("6");
    }
    else
    {
        ui->le->setText(ui->le->text()+"6");
    }
}

void MainWindow::on_pB7_clicked()
{
    if (iBase*iBase<64) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("7");
    }
    else
    {
        ui->le->setText(ui->le->text()+"7");
    }
}

void MainWindow::on_pB8_clicked()
{
    if (iBase*iBase<81) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("8");
    }
    else
    {
        ui->le->setText(ui->le->text()+"8");
    }
}

void MainWindow::on_pB9_clicked()
{
    if (iBase*iBase<100) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("9");
    }
    else
    {
        ui->le->setText(ui->le->text()+"9");
    }
}
void MainWindow::on_pBA_clicked()
{
    if (iBase*iBase<121) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("A");
    }
    else
    {
        ui->le->setText(ui->le->text()+"A");
    }
}

void MainWindow::on_pBB_clicked()
{
    if (iBase*iBase<144) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("B");
    }
    else
    {
        ui->le->setText(ui->le->text()+"B");
    }
}

void MainWindow::on_pBC_clicked()
{
    if (iBase*iBase<169) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("C");
    }
    else
    {
        ui->le->setText(ui->le->text()+"C");
    }
}

void MainWindow::on_pBD_clicked()
{
    if (iBase*iBase<196) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("D");
    }
    else
    {
        ui->le->setText(ui->le->text()+"D");
    }
}
void MainWindow::on_pBE_clicked()
{
    if (iBase*iBase<225) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("E");
    }
    else
    {
        ui->le->setText(ui->le->text()+"E");
    }
}
void MainWindow::on_pBF_clicked()
{
    if (iBase*iBase<256) return;

    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
    }
    if (ui->le->text().trimmed()=="0")
    {
        ui->le->setText("F");
    }
    else
    {
        ui->le->setText(ui->le->text()+"F");
    }
}
void MainWindow::on_pB0_clicked()
{
    if (bClear==true)
    {
        ui->le->clear();
        bClear=false;
        ui->le->setText(ui->le->text()+"0");
        return;
    }
    if (ui->le->text().trimmed()=="")
    {
        ui->le->setText("1");
    }
    if (ui->le->text().trimmed()!="0")
    {
        ui->le->setText(ui->le->text()+"0");
    }
}

void MainWindow::on_pbPlus_clicked()
{
    Calc("+");
}

void MainWindow::on_pbC_clicked()
{
    bClear=false;
    ui->le->setText("0");
    bVal1=false;
    bVal2=false;
    mpz_set_ui(mzVal1,0);
    mpz_set_ui(mzVal2,0);
    mpz_set_ui(mzResult,0);
}

void MainWindow::on_pbBack_clicked()
{
    if (ui->le->text().trimmed().length()>1)
    {
        ui->le->setText(ui->le->text().trimmed().left(ui->le->text().trimmed().length()-1));
        if (ui->le->text().trimmed()=="-")
        {
            ui->le->setText("0");
        }
    }
    else
    {
        ui->le->setText("0");
    }
}

void MainWindow::on_pbEq_clicked()
{
    bool bOk;

    char *cBuf=new char[ulLen];

    if (ui->le->text().trimmed()!="")
    {
        bClear=true;
        if (bVal1==false)
        {
            return;
        }
        if ((bVal1==true)&&(bVal2==false))
        {
            mpz_set_str(mzVal2,ui->le->text().trimmed().toAscii(),iBase);
            if (strCurrentEvent=="+")
            {
               mpz_add(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="-")
            {
                mpz_sub(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="*")
            {
                mpz_mul(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="/")
            {
                mpz_cdiv_q(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="mod")
            {
                mpz_mod(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="gcd")
            {
                mpz_gcd(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="lcm")
            {
                mpz_lcm(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="jac")
            {
                mpz_set_si(mzResult,mpz_jacobi(mzVal1,mzVal2));
            }
            if (strCurrentEvent=="and")
            {
                mpz_and(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="or")
            {
                mpz_ior(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="xor")
            {
                mpz_xor(mzResult,mzVal1,mzVal2);
            }
            if (strCurrentEvent=="lsh")
            {
                mpz_setbit(mzResult,5);
            }
            if (strCurrentEvent=="rtn")
            {
                ulN=ui->le->text().trimmed().toLong(&bOk,iBase);
                if (!bOk) return;
                mpz_root(mzResult,mzVal1,ulN);
                ulN=0;
            }
            if (strCurrentEvent=="pow")
            {
                ulN=ui->le->text().trimmed().toLong(&bOk,iBase);
                if (!bOk) return;
                mpz_pow_ui(mzResult,mzVal1,ulN);
                ulN=0;
            }
            mpz_set(mzVal1,mzResult);
            mpz_set_ui(mzVal2,0);
            //gmp_sprintf(cBuf,"%Zd",mzResult);
            mpz_get_str(cBuf,iBase,mzResult);
            ui->le->setText(QString(cBuf));
            bVal1=false;
        }
    }
    else
    {
        strCurrentEvent.clear();
        return;
    }
}

void MainWindow::on_pbMinus_clicked()
{
    Calc("-");
}

void MainWindow::on_pbMul_clicked()
{
    Calc("*");
}

void MainWindow::on_pbDiv_clicked()
{
    Calc("/");
}

void MainWindow::on_pBNeg_clicked()
{
    if (ui->le->text().indexOf("-")>=0)
    {
        ui->le->setText(ui->le->text().replace("-",""));
    }
    else
    {
        ui->le->setText("-"+ui->le->text());
    }
}

void MainWindow::on_pbMod_clicked()
{
    Calc("mod");
}

void MainWindow::on_pbGcd_clicked()
{
    Calc("gcd");
}

void MainWindow::on_pbLcm_clicked()
{
    Calc("lcm");
}


void MainWindow::on_rbBin_clicked(bool checked)
{
    char *cBuf=new char[ulLen];
    mpz_t mzTmp;

    ui->pB2->setEnabled(false);
    ui->pB3->setEnabled(false);
    ui->pB4->setEnabled(false);
    ui->pB5->setEnabled(false);
    ui->pB6->setEnabled(false);
    ui->pB7->setEnabled(false);
    ui->pB8->setEnabled(false);
    ui->pB9->setEnabled(false);
    ui->pBA->setEnabled(false);
    ui->pBB->setEnabled(false);
    ui->pBC->setEnabled(false);
    ui->pBD->setEnabled(false);
    ui->pBE->setEnabled(false);
    ui->pBF->setEnabled(false);

    mpz_init(mzTmp);
    if (checked==true)
    {
         mpz_set_str(mzTmp,ui->le->text().trimmed().toAscii(),iBase);
         iBase=2;
         mpz_get_str(cBuf,iBase,mzTmp);
         ui->le->setText(QString(cBuf));
    }
    mpz_clear(mzTmp);
}


void MainWindow::on_rbDec_clicked(bool checked)
{
    ui->pB2->setEnabled(true);
    ui->pB3->setEnabled(true);
    ui->pB4->setEnabled(true);
    ui->pB5->setEnabled(true);
    ui->pB6->setEnabled(true);
    ui->pB7->setEnabled(true);
    ui->pB8->setEnabled(true);
    ui->pB9->setEnabled(true);
    ui->pBA->setEnabled(false);
    ui->pBB->setEnabled(false);
    ui->pBC->setEnabled(false);
    ui->pBD->setEnabled(false);
    ui->pBE->setEnabled(false);
    ui->pBF->setEnabled(false);

    char *cBuf=new char[ulLen];
    mpz_t mzTmp;

    mpz_init(mzTmp);
    if (checked==true)
    {
         mpz_set_str(mzTmp,ui->le->text().trimmed().toAscii(),iBase);
         iBase=10;
         mpz_get_str(cBuf,iBase,mzTmp);
         ui->le->setText(QString(cBuf));
    }
    mpz_clear(mzTmp);
}

void MainWindow::on_rbHex_clicked(bool checked)
{
    char *cBuf=new char[ulLen];
    mpz_t mzTmp;

    ui->pB2->setEnabled(true);
    ui->pB3->setEnabled(true);
    ui->pB4->setEnabled(true);
    ui->pB5->setEnabled(true);
    ui->pB6->setEnabled(true);
    ui->pB7->setEnabled(true);
    ui->pB8->setEnabled(true);
    ui->pB9->setEnabled(true);
    ui->pBA->setEnabled(true);
    ui->pBB->setEnabled(true);
    ui->pBC->setEnabled(true);
    ui->pBD->setEnabled(true);
    ui->pBE->setEnabled(true);
    ui->pBF->setEnabled(true);

    mpz_init(mzTmp);
    if (checked==true)
    {
         mpz_set_str(mzTmp,ui->le->text().trimmed().toAscii(),iBase);
         iBase=16;
         mpz_get_str(cBuf,iBase,mzTmp);
         ui->le->setText(QString(cBuf));
    }
    mpz_clear(mzTmp);
}

void MainWindow::on_rbOct_clicked(bool checked)
{
    ui->pB2->setEnabled(true);
    ui->pB3->setEnabled(true);
    ui->pB4->setEnabled(true);
    ui->pB5->setEnabled(true);
    ui->pB6->setEnabled(true);
    ui->pB7->setEnabled(true);
    ui->pB8->setEnabled(false);
    ui->pB9->setEnabled(false);
    ui->pBA->setEnabled(false);
    ui->pBB->setEnabled(false);
    ui->pBC->setEnabled(false);
    ui->pBD->setEnabled(false);
    ui->pBE->setEnabled(false);
    ui->pBF->setEnabled(false);

    char *cBuf=new char[ulLen];
    mpz_t mzTmp;

    mpz_init(mzTmp);
    if (checked==true)
    {
         mpz_set_str(mzTmp,ui->le->text().trimmed().toAscii(),iBase);
         iBase=8;
         mpz_get_str(cBuf,iBase,mzTmp);
         ui->le->setText(QString(cBuf));
    }
    mpz_clear(mzTmp);
}

void MainWindow::on_leBase_editingFinished()
{
    char *cBuf=new char[ulLen];
    mpz_t mzTmp;
    bool bOk;
    QIntValidator qivTop(2, 63, this);
    QIntValidator qivBottom(-32, -2, this);
    QString str;
    int pos = 0;

    str = ui->leBase->text();
    if (ui->rbOther->isChecked()==true)
    {
        mpz_init(mzTmp);
        mpz_set_str(mzTmp,ui->le->text().trimmed().toAscii(),iBase);
        if (qivTop.validate(str,pos)||qivBottom.validate(str,pos)==2)
        {
            iBase=ui->leBase->text().toInt(&bOk);
            mpz_get_str(cBuf,iBase,mzTmp);
            ui->le->setText(QString(cBuf));
            mpz_clear(mzTmp);
        }
    }
    delete cBuf;
}

void MainWindow::on_rbOther_clicked(bool checked)
{
    char *cBuf=new char[ulLen];
    mpz_t mzTmp;
    bool bOk;
    QIntValidator qivTop(2, 63, this);
    QIntValidator qivBottom(-32, -2, this);
    QString str;
    int pos = 0;

    mpz_init(mzTmp);
    if (checked==true)
    {
         mpz_set_str(mzTmp,ui->le->text().trimmed().toAscii(),iBase);
         if (qivTop.validate(str,pos)||qivBottom.validate(str,pos)==2)
         {
            iBase=ui->leBase->text().trimmed().toInt(&bOk);
            mpz_get_str(cBuf,iBase,mzTmp);
            ui->le->setText(QString(cBuf));
         }
    }
    mpz_clear(mzTmp);
    delete cBuf;
}



void MainWindow::on_pbJac_clicked()
{
    char *cBuf=new char[ulLen];
    int iResult;

    if (ui->le->text().trimmed()!="")
    {
        bClear=true;
        if (bVal1==false)
        {
            mpz_set_str(mzVal1,ui->le->text().trimmed().toAscii(),iBase);
            strCurrentEvent="jac";
            bVal1=true;
            return;
        }
        if ((bVal1==true)&&(bVal2==false))
        {
            mpz_set_str(mzVal2,ui->le->text().trimmed().toAscii(),iBase);
            if (strCurrentEvent=="jac")
            {
                iResult=mpz_jacobi(mzVal1,mzVal2);
            }
            strCurrentEvent="jac";
            mpz_set_si(mzVal1,iResult);
            mpz_set_ui(mzVal2,0);
            mpz_get_str(cBuf,iBase,mzVal1);
            ui->le->setText(QString(cBuf));
        }
    }
    else
    {
        return;
    }
}

void MainWindow::on_pbLeg_clicked()
{
    char *cBuf=new char[ulLen];
    int iResult;

    if (ui->le->text().trimmed()!="")
    {
        bClear=true;
        if (bVal1==false)
        {
            mpz_set_str(mzVal1,ui->le->text().trimmed().toAscii(),iBase);
            strCurrentEvent="leg";
            bVal1=true;
            return;
        }
        if ((bVal1==true)&&(bVal2==false))
        {
            mpz_set_str(mzVal2,ui->le->text().trimmed().toAscii(),iBase);
            if (strCurrentEvent=="leg")
            {
                iResult=mpz_legendre(mzVal1,mzVal2);
            }
            strCurrentEvent="leg";
            mpz_set_si(mzVal1,iResult);
            mpz_set_ui(mzVal2,0);
            mpz_get_str(cBuf,iBase,mzVal1);
            ui->le->setText(QString(cBuf));
        }
    }
    else
    {
        return;
    }
}

void MainWindow::on_pbAnd_clicked()
{
    Calc("and");
}

void MainWindow::on_pbOr_clicked()
{
    Calc("or");
}

void MainWindow::on_pbXor_clicked()
{
    Calc("xor");
}

void MainWindow::on_pbSqrt_clicked()
{
    char *cBuf=new char[ulLen];

    if (ui->le->text().trimmed()!="")
    {
        mpz_set_str(mzVal1,ui->le->text().trimmed().toAscii(),iBase);
        mpz_sqrt(mzResult,mzVal1);
        mpz_set(mzVal1,mzResult);
        mpz_get_str(cBuf,iBase,mzVal1);
        ui->le->setText(QString(cBuf));
    }
}

void MainWindow::on_pbRtn_clicked()
{
    char *cBuf=new char[ulLen];
    bool bOk;

    if (ui->le->text().trimmed()!="")
    {
        bClear=true;
        if (bVal1==false)
        {
            mpz_set_str(mzVal1,ui->le->text().trimmed().toAscii(),iBase);
            strCurrentEvent="rtn";
            bVal1=true;
            return;
        }
        if ((bVal1==true)&&(bVal2==false))
        {
            ulN=ui->le->text().trimmed().toLong(&bOk,iBase);
            if (!bOk) return;
            if (strCurrentEvent=="rtn")
            {
                mpz_root(mzResult,mzVal1,ulN);
            }
            strCurrentEvent="rtn";
            mpz_set(mzVal1,mzResult);

            ulN=0;
            mpz_get_str(cBuf,iBase,mzResult);
            ui->le->setText(QString(cBuf));
        }
    }
    else
    {
        return;
    }

    delete cBuf;
}

void MainWindow::on_pbPow_clicked()
{
    char *cBuf=new char[ulLen];
    bool bOk;

    if (ui->le->text().trimmed()!="")
    {
        bClear=true;
        if (bVal1==false)
        {
            mpz_set_str(mzVal1,ui->le->text().trimmed().toAscii(),iBase);
            strCurrentEvent="pow";
            bVal1=true;
            return;
        }
        if ((bVal1==true)&&(bVal2==false))
        {
            ulN=ui->le->text().trimmed().toLong(&bOk,iBase);
            if (!bOk) return;
            if (strCurrentEvent=="pow")
            {
                mpz_pow_ui(mzResult,mzVal1,ulN);
            }
            strCurrentEvent="pow";
            mpz_set(mzVal1,mzResult);

            ulN=0;
            mpz_get_str(cBuf,iBase,mzResult);
            ui->le->setText(QString(cBuf));
        }
    }
    else
    {
        return;
    }

    delete cBuf;
}
