#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QMessageBox>
#include <QKeyEvent>
#include <QDebug>
#include <QRadioButton>
#include <QIntValidator>
#include <gmp.h>

namespace Ui
{
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Ui::MainWindow *ui;
    void keyPressEvent(QKeyEvent * event);
    void Calc(QString strOper);
    mpz_t mzVal1;
    mpz_t mzVal2;
    mpz_t mzResult;
    QString strCurrentEvent;
    bool bClear;
    bool bVal1;
    bool bVal2;
    int iBase;
    unsigned long ulLen;
    unsigned long ulN;



private slots:
    void on_pbPow_clicked();
    void on_pbRtn_clicked();
    void on_pbSqrt_clicked();
    void on_pbXor_clicked();
    void on_pbOr_clicked();
    void on_pbAnd_clicked();
    void on_pbLeg_clicked();
    void on_pbJac_clicked();
    void on_rbOther_clicked(bool checked);
    void on_leBase_editingFinished();
    void on_pBE_clicked();
    void on_pBF_clicked();
    void on_pBD_clicked();
    void on_pBC_clicked();
    void on_pBB_clicked();
    void on_pBA_clicked();
    void on_pB9_clicked();
    void on_pB8_clicked();
    void on_pB7_clicked();
    void on_pB6_clicked();
    void on_pB5_clicked();
    void on_pB4_clicked();
    void on_rbOct_clicked(bool checked);
    void on_rbHex_clicked(bool checked);
    void on_rbDec_clicked(bool checked);
    void on_rbBin_clicked(bool checked);
    void on_pbLcm_clicked();
    void on_pbGcd_clicked();
    void on_pbMod_clicked();
    void on_pBNeg_clicked();
    void on_pbDiv_clicked();
    void on_pbMul_clicked();
    void on_pbMinus_clicked();
    void on_pbEq_clicked();
    void on_pbBack_clicked();
    void on_pbC_clicked();
    void on_pbPlus_clicked();
    void on_pB0_clicked();
    void on_pB3_clicked();
    void on_pB2_clicked();
    void on_pB1_clicked();
};

#endif // MAINWINDOW_H
